using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace skyscraper5.Skyscraper.Text.Encodings
{
    [SkyscraperEncoding("dvb-iso-8859-1")]
    class dvb_iso_8859_1 : SkyscraperBaseEncoding8
    {
        protected override char[] Decrypt(byte[] preprocessed)
        {
            StringBuilder resultBuilder = new StringBuilder();
            for (int i = 0; i < preprocessed.Length; i++)
            {
                if (preprocessed[i] <= 0x7e)
                {
                    AsciiTable.GetAsciiChar(preprocessed[i], resultBuilder);
                    continue;
                }
                switch (preprocessed[i])
                {
                    case 0xa0: resultBuilder.Append('\u00a0'); break;
                    case 0xb0: resultBuilder.Append('°'); break;
                    case 0xb2: resultBuilder.Append('²'); break;
                    case 0xb4: resultBuilder.Append('´'); break;
                    case 0xbc: resultBuilder.Append('¼'); break;
                    case 0xc0: resultBuilder.Append('À'); break;
                    case 0xc1: resultBuilder.Append('Á'); break;
                    case 0xc4: resultBuilder.Append('Ä'); break;
                    case 0xc7: resultBuilder.Append('Ç'); break;
                    case 0xc9: resultBuilder.Append('É'); break;
                    case 0xcb: resultBuilder.Append('¼'); break;
                    case 0xcd: resultBuilder.Append('Í'); break;
                    case 0xd6: resultBuilder.Append('Ö'); break;
                    case 0xdc: resultBuilder.Append('Ü'); break;
                    case 0xdf: resultBuilder.Append('ß'); break;
                    case 0xe0: resultBuilder.Append('à'); break;
                    case 0xe1: resultBuilder.Append('á'); break;
                    case 0xe2: resultBuilder.Append('â'); break;
                    case 0xe4: resultBuilder.Append('ä'); break;
                    case 0xe5: resultBuilder.Append('å'); break;
                    case 0xe7: resultBuilder.Append('ç'); break;
                    case 0xe8: resultBuilder.Append('è'); break;
                    case 0xe9: resultBuilder.Append('é'); break;
                    case 0xea: resultBuilder.Append('ê'); break;
                    case 0xeb: resultBuilder.Append('ë'); break;
                    case 0xec: resultBuilder.Append('ì'); break;
                    case 0xed: resultBuilder.Append('í'); break;
                    case 0xee: resultBuilder.Append('î'); break;
                    case 0xef: resultBuilder.Append('ï'); break;
                    case 0xf1: resultBuilder.Append('ñ'); break;
                    case 0xf2: resultBuilder.Append('ò'); break;
                    case 0xf3: resultBuilder.Append('ó'); break;
                    case 0xf4: resultBuilder.Append('ô'); break;
                    case 0xf6: resultBuilder.Append('ö'); break;
                    case 0xf8: resultBuilder.Append('ø'); break;
                    case 0xf9: resultBuilder.Append('ù'); break;
                    case 0xfa: resultBuilder.Append('ú'); break;
                    case 0xfb: resultBuilder.Append('û'); break;
                    case 0xfc: resultBuilder.Append('ü'); break;
                    case 0xfd: resultBuilder.Append('ý'); break;
                    default:
                        throw new NotImplementedException(String.Format("0x{0:X2}", preprocessed[i]));
                }
            }

            return resultBuilder.ToString().ToCharArray();
        }
    }
}
